<?php
require_once "inc/syntax/clsstdgrid.php";
/***** TARPIT GRID - Grid read from binary file ******************/
class cTarpitGrid extends cStdGrid
{
	function cTarpitGrid($name){
		$this->Name = $name;
		$this->Filename = $_SESSION["CONFIGPATH"]."tarpit.dat";
	}
	function loadFromBuffer()
	{
    if ($this->Buffer){
    $i = 1;$j=0;
      while ($i<strlen($this->Buffer)) {
    	  $item['ip'] = substr($this->Buffer,$i,55);$i+=55;
        $item['separator'] = substr($this->Buffer,$i,1);$i+=1;
        $item['timestamp'] = substr($this->Buffer,$i,8);$i+=8;
        $items[$j++] = $item;
      }
    }
    $this->Data = $items;
	}
	function saveToBuffer()
	{
      $return="";
      if ($this->Data)
      foreach($this->Data as $val){
         $return.=$val['ip'];
         $return.=$val['separator'];
         $return.=$val['timestamp']; 
      }
    return $return;
	}
}
/***** RELAY GRID - Grid combined from file and api ******************/
class cRelayGrid extends cStdGrid
{
	function cRelayGrid($name){
		$this->Item = new cStdItem(1,0);
		$this->Name = $name;
		$this->Filename = $_SESSION["CONFIGPATH"]."relay.dat";
	}
	function LoadFromAPI()
	{
		$api = createobject("api");
		$list = $api->GetProperty("C_Mail_Security_Relay_IPList");
  	$items = explode(";",$list);
    for ($i = 0; $i < count($items)-1; $i++){
      $return[$i][0] = $items[$i];
      $this->APIIndex[] = $i;
      }
    return $return;
	}

	/* Build grid from session */
	function loadFromSession()
	{
		 $this->Data = $_SESSION["griddata"]["grids"][$this->Name];
		 $this->APIIndex = $_SESSION["griddata"]["gridinfo"][$this->Name]["APIIndex"];
	}
	function Load($gObj,$array)
	{
		if (!$array) $this->GetBuffer($gObj->Buffer);
      $this->LoadFromBuffer();
      $apiIPs = $this->LoadFromAPI();
      $fileIPs = $this->Data;
      if (!is_array($apiIPs)) $apiIPs = array();
      if (!is_array($fileIPs)) $fileIPs = array();
      $this->Data = array_merge($apiIPs,$fileIPs);
  		if (!$array) $this->SaveToSession($gObj);
  }
	function saveToSession()
	{
		$_SESSION["griddata"]["grids"][$this->Name] = $this->Data;
		$_SESSION["griddata"]["gridinfo"][$this->Name]["APIIndex"] = $this->APIIndex;
	}
	/* Save grid to buffer */
	function saveToBuffer(&$apibuffer)
	{
		$buffer="";$apibuffer="";
		if ($this->Data)
		foreach ($this->Data as $i => $val){
			if ($this->Item->Length==1) {
         if(in_array($i,$this->APIIndex)) $apibuffer.=$this->Data[$i][0].";";
			 	 else $buffer.= $this->Data[$i][0] . CRLF;
			}else{
				for ($j=0;$j<$this->Item->Length-1;$j++){
				  if(in_array($i,$this->APIIndex)) $apibuffer.=$this->Data[$i][$j].$this->Item->Seps[$j];
			 	  else $buffer.=$this->Data[$i][$j].$this->Item->Seps[$j];
				}
				if(in_array($i,$this->APIIndex)) $apibuffer.=$this->Data[$i][$j].";";
        else $buffer.= $this->Data[$i][$j] . CRLF;
			}
		}
		$this->Buffer = $buffer;
		return $buffer;
	}
  function Save()
  {
    $return = $this->saveToBuffer($iplist);
    if ($return!="" || $iplist!="") {
      $fp = fopen($this->Filename,"w");
  		fwrite($fp,$return,strlen($return));
  		fclose($fp);
  		$api = createobject("api");
  		$api->SetProperty("C_Mail_Security_Relay_IPList",$iplist);
  		$api->Save();
  		unset($api);
    }else @unlink($this->Filename);
  }
}
?>
