<?php

require_once 'inc/encode.php';

class Tools
{
	/*************************************** Public **************************************/
	public static function charsetConvert($text, $from, $to)
	{
		return @iconv($from,$to, $text);
/*		
		OLD USAGE OF THIS FILE, KEPT ONLY FOR POSSIBLE FURTHER REUSAGE
		
		global $nonconvert;
		
		if($from && strtolower($from) == strtolower($to)) return $text = eregi_replace("\?[a-z0-9\-]*\?Q\?", "", $text);
		
		$to2 = '';
		if(strtolower($to) == "windows-1250")
		{
			$to = "iso-8859-2";
			$to2 = "windows-1250";
		}
		elseif ($to == "mycharset") $to = charset; //wap
		
		if(strtolower($from) == "windows-1250") //1250 to 8859-2
		{
			$text = StrTr($text,"\x8A\x8D\x8E\x9A\x9D\x9E", "\xA9\xAB\xAE\xB9\xBB\xBE");
			$from = "iso-8859-2";
		}
		
		if($text && $from && $to && !@in_array(strtolower($to), $nonconvert) && !@in_array(strtolower($from), $nonconvert))
		{
			$text2 = @iconv($from,$to, $text);
			$text = $text2 ? $text2: $text;
		}
		
		if(strtolower($to2) == "windows-1250") //8859-2 to 1250
		{
			$text = StrTr($text,"\xA9\xAB\xAE\xB9\xBB\xBE", "\x8A\x8D\x8E\x9A\x9D\x9E");
		}
		
		$text = eregi_replace("\?[a-z0-9\-]*\?Q\?", " ", $text);
		
		return $text;
*/
	}
	
	public static function putheader($header, $mycharset="", $emails = false)
	{
		$out = $fheader = trim($header);
		$mycharset = $mycharset ? $mycharset: mycharset;
		
		if (Tools::isabovechar($fheader))
		{
			$i = 1;
			if($emails && strpos($fheader, ">"))
			{
				$arr = explode(">", $header);
				
				foreach($arr as $val)
				{
					if(!strlen($val)) continue;
					unset($val2);
					if(strpos($val,"<") > -1) $val .= ">";
					
					if(!eregi("(.*)(<.*[^>]*>)", $val, $val2)) $val2[1] = $val;
					$val2[1] = ereg_replace("^[,;]", "", trim($val2[1]));
					
					if(Tools::isabovechar($val2[1]))
						$out2 .= "=?" . strtoupper($mycharset) . "?Q?" . Tools::converttoquoted($val2[1]) . "?=";
					else
						$out2 .= $val2[1];
					
					if($val2[2]) $out2 .= ' '.Tools::converttoquoted($val2[2]).";";
				}
				
				if(isset($out2)) $out = $val2[2] ? substr($out2,0,-1): $out2;
			} 
			else 
			{
				$out = "=?" . strtoupper($mycharset) . "?Q?" . Tools::converttoquoted($fheader) . "?=";
			}
		}

		return $out;
	}
	
	public static function validateTemp($path)
	{
		// TODO
		return true;
	}
	
	public static function isIE()
	{
		$agent = $_SERVER['HTTP_USER_AGENT'];
		if (strpos($agent,'MSIE') !== false && strpos($agent,'Opera') === false)
			return true;
		else
			return false;
	}
	
	public static function sendFileHeaders($fileName, $length, $contentType)
	{
		if (Tools::isIE())
			$fileName = urlencode($fileName);

		header('Pragma: ');		// leave blank to avoid IE errors
		header('Cache-Control: '); // leave blank to avoid IE errors
		header('Content-Type: ' . $contentType);
		header('Content-Disposition: attachment; filename="' . $fileName . '"');
		header('Content-Length: ' . $length);		
	}
	
	
	public static function removeHTML($message)
	{
		// Convert CRLF
		$message = ereg_replace("(\n)|(\r\n)","",$message);
		$message = eregi_replace("<li[^>]*>","\r\n - ",$message);
		$message = eregi_replace("<td[^>]*>"," ",$message);
		$message = eregi_replace("<(p|br|hr|tr)[^>]*>","\r\n",$message);
		// Strip all HTML and PHP Tags
		$message = strip_tags($message);
		// Replace all entities
		$message = eregi_replace("&nbsp;", " ", $message);
		$message = eregi_replace("&amp;", "&", $message);
		$message = eregi_replace("&quot;", "\"", $message);
		$message = eregi_replace("&apos;", "'", $message);
		$message = eregi_replace("&lt;", "<", $message);
		$message = eregi_replace("&gt;", ">", $message);
		
		return $message;
	}
	
	public static function dotConvert($value)
	{
		if ($value) if ($value[0] == ".") $value = "." . $value;
		return str_replace("\n.", "\n.." , $value);
	}
	
	public static function cr2crlf($string)
	{
		$string = str_replace("\x0D", "", $string);
		return str_replace("\x0A", "\x0D\x0A", $string);
	}
	
	/*************************************** Private **************************************/
	public static function converttoquoted($string)
	{
		$converted = "";
		for ($i = 0; $i < strlen($string); $i++) {
			if ((ord($string[$i]) > 127) || ($string[$i] == "=") || ($string[$i] == "_")) {
				$converted .= "=" . Tools::fillstr(strtoupper(dechex(ord($string[$i]))), 2, "0");
			} else {
				$converted .= $string[$i];
			} 
		}
		return $converted;
	}
	
	public static function isabovechar($string)
	{
		for ($i = 0; $i < strlen($string); $i++)
			if (ord($string[$i]) > 127) return true;
			
		return false;
	}
	
	public static function fillstr($str, $size, $char)
	{
		if (strlen($str) > $size) return substr($str, 0, $size);
		
		$value = $str;
		for ($i = strlen($str); $i < $size; $i++) {
			$value = $char . $value;
		}
		
		return $value;
	}
		 /**
	  @brief Converts parsed item array into xml string.
	  @param $item parsed item array.
	  @param $filter GW array result.
	  */
		public static function makeXMLTags($item,$tags = '*')
		{
		$return = '';
		$tags = strtolower($tags);
		$tags = explode(",",$tags);

    if (is_array($item)) foreach ($item as $tag => $value){
				$tag = strtolower($tag);

				//If there are selected tags and current tag is not in there
				if ($tags[0]!='*' && in_array($tag,$tags)==0) continue;
	
				if (isset($value) && $value !== '') $return.='<'.$tag.'>'.htmlspecialchars(trim($value)).'</'.$tag.'>';
				else		$return.='<'.$tag.'/>';
			}
			return $return;
		}
	  
		/**
	  @brief Converts xml into into array
	  @param $oXMLNode node element.
	  @param $filter folder result.
	  */		
		public static function makeArrayFromXML($oXMLNode,$bBlankTags = false)
		{
		  $itm = array();
			 if ($oXMLNode->hasChildNodes())
			  foreach ($oXMLNode->childNodes as $node)
				  if ($node->nodeValue !== '' || $bBlankTags)
						$itm[strtolower($node->nodeName)] = $node->nodeValue;
		 

		  return $itm;
		}
		
		public static function makeTreeFromXML($oXMLNode)
		{
		  $itm = array();
		  
		  
      if ($oXMLNode->hasAttributes())
        foreach($oXMLNode->attributes as $attr)
          $itm['@attributes'][$attr->name] = encodeHTML($attr->value);
      
    		  
      $oldname ='';
      if ($oXMLNode->hasChildNodes()) 
        foreach($oXMLNode->childNodes as $node)
        {
          //Count items with the same name
          if ($oldname != $node->nodeName) 
            $nCount = 0;  

          $oldname = $node->nodeName;

          if ($node->nodeName=='#text')
            $itm['@value'] = encodeHTML($node->nodeValue);
          else {
           if ($uid = $node->getAttribute('uid'))
              $itm['@childnodes'][strtolower($node->nodeName)][$uid] = 
                self::makeTreeFromXML($node);
           else
              $itm['@childnodes'][strtolower($node->nodeName)][$nCount++] = 
              self::makeTreeFromXML($node);
          }
        }
      return $itm;    
		}
		
		/**
		 @brief Converts string representin an XML document into simple XML containing parsed JS array string.
		 @param $XMLString XML string.
		 @return Simple XML containing parsed JS array string.
		*/
		public static function str2JSArray(&$XMLString) {
			$array = array();

			$xml = @simplexml_load_string($XMLString);
			if (!$xml)
			{
				$xml = mb_convert_encoding($XMLString,'UTF-8');
				$xml = @simplexml_load_string($xml); 
			}

			$rootName = strtoupper(dom_import_simplexml($xml)->nodeName);
			self::makeJSArray($xml, $array[$rootName][0]);
			return json_encode($array);
		}

		/**
		 @brief Converts Simple XML object into array that is used within JS on client.
		 @param $parent Simple XML node being processed.
		 @param[in,out] $output JS-like array.
		*/
		private static function makeJSArray($parent, &$output) {
			
			$hasChild = false;
			foreach ($parent->children() as $name => $child) {
				$output2 = &$output[strtoupper($name)][];
				self::makeJSArray($child, $output2);
				$hasChild = true;
			}
			
			if (($value = trim((string)$parent)) != '')
				$output['VALUE'] = $value;
			else if (!$hasChild)
				$output = array();
			
			foreach ($parent->attributes() as $attName => $attValue) {
				$output['ATTRIBUTES'][strtoupper($attName)] = (string)$attValue;
			}
		}
		
		public static function makeXMLStringFromTree($aArray,$sTagName = 'documentElement')
		{ 
		  //Init
		  $sStart = $sEnd = $sValue = $sReturn = '';

      //Transform attributes
      if (is_array($aArray['@attributes'])){
        foreach($aArray['@attributes'] as $attname => $attvalue)
          $sAttributes.=' '.$attname.'="'.$attvalue.'"';
      }
      
      //Process childnodes
      if (is_array($aArray['@childnodes'])){
        foreach($aArray['@childnodes'] as $chName => $chValue)
          foreach($chValue as $chVal)
            $sValue.= Tools::makeXMLStringFromTree($chVal,$chName);
      }
      //Set value
      if (isset($aArray['@value']))
        $sValue .= $aArray['@value'];
    
      //No pair-tag
      if (!isset($aArray['@value']) && !isset($aArray['@childnodes']))
        $sReturn = '<'.$sTagName.$sAttributes.'/>';
      else 
        $sReturn = '<'.$sTagName.$sAttributes.'>'.$sValue.'</'.$sTagName.'>';    
      
      return $sReturn;
    }
    	  
		public static function binary2decimal($num)
		{
			$dec = 0;
			for ($i=0;$i<sizeof($num);$i++){
	  		$dec+=pow(2,$i)*$num[$i];
	  	}
	  	return $dec;
		}

		public static function decimal2binary($num,$length = 7)
		{
			$i = 0;
			while ($num!=0){
	  		$binary[$i++] = $num%2;
	  		if (($num - $num%2)!=0) $num = ($num - $num%2)/2;
	  		else					$num = 0;
	  	}
	  	while (count(@$binary)!=$length)
	  		$binary[$i++] = 0;
	  	return $binary;
		}	
		
    public static function securePath($path) 
    { 
      if (ereg("(\.\.)|(:)", $path) || $path[0]=="/" || $path[0]=="\\") $path=false;
      return $path;   
    }
    
    public static function deleteDir($dir)
    {
       if (substr($dir, strlen($dir)-1, 1) != '/')
           $dir .= '/';
    
       if ($handle = opendir($dir))
       {
           while ($obj = readdir($handle))
           {
               if ($obj != '.' && $obj != '..')
               {
                   if (is_dir($dir.$obj))
                   {
                       if (!self::deleteDir($dir.$obj))
                           return false;
                   }
                   elseif (is_file($dir.$obj))
                   {
                       if (!unlink($dir.$obj))
                           return false;
                   }
               }
           }
    
           closedir($handle);
    
           if (!@rmdir($dir))
               return false;
           return true;
       }
       return false;
    }
    
  public static function createURL($array) {
		if(!is_array($array)) return '';
		$result = '';
		$first = true;
		foreach($array as $k => $v) {
			if ($first)
				$first = false;
			else
				$result .= '&';
			
			$result .= $k. "=" . encodeURL($v);
		}
		return $result;
	}

	public static function parseURL($line){
		if (!$line) return array();
		
		$result = array();
		$fields = explode("&", $line);

		// Get all lines array
		foreach ($fields as $item){
			$pos = strpos($item, '=');
			if ($pos === false)
				continue;
			$key = substr($item, 0, $pos);
			$value = substr($item, $pos+1);
			$result[$key] = decodeURL($value);
		}

		return $result;
	}


    
    public static function mkdir_r($dirName, $rights=0777){
       $dirs = explode('/', $dirName);
       $dir='';
       foreach ($dirs as $part) {
           $dir.=$part.'/';
           if (!is_dir($dir) && strlen($dir)>0)
               mkdir($dir, $rights);
       }
    }
    
    //This function is an altenative to the standard
    //explode funct. but it unsets the last element in array
    //(for strings with separator at the end)
    public static function explode_j($sep,$string)
    {
      $return = explode($sep,$string);
      unset($return[count($return)-1]);
      return $return;
    }
    public static function parseFullPath($fullPath,$class)
    {
      switch($class)
      {
        // Parse "folder/item"
        case 'file':    
          $lastSlash = strrpos($fullPath,"/");
                    
          $attData['item'] = substr($fullPath,$lastSlash+1);
          $attData['folder'] = substr($fullPath,0,$lastSlash);                                                         
          break;
          
        //Parse "account/folder/item"
        case 'itemlink':
        case 'item':
          $lastSlash = strrpos($fullPath,"/");
          $firstSlash = strpos($fullPath,"/");
                    
          $attData['item'] = substr($fullPath,$lastSlash+1);
          $attData['account'] = substr($fullPath,0,$firstSlash);
          $attData['folder'] = substr($fullPath,$firstSlash+1,$lastSlash-$firstSlash-1);
        
          break;
          
        //Parse "account/folder/item/part"
        case 'attachment':
          $lastSlash = strrpos($fullPath,"/");
          $preLastSlash = strrpos(substr($fullPath,0,$lastSlash),"/");
          $firstSlash = strpos($fullPath,"/");
                    
          $attData['part'] = substr($fullPath,$lastSlash+1);
          $attData['item'] = substr($fullPath,$preLastSlash+1,$lastSlash-$preLastSlash-1);
          $attData['account'] = substr($fullPath,0,$firstSlash);
          $attData['folder'] = substr($fullPath,$firstSlash+1,$preLastSlash-$firstSlash-1);
                        
          break;

        //Parse ""
        case 'url':
        //Not implemented yet
        break;
        
        default:
          throw new Exc('Unknown attachment class');        
        break;

      }
      return $attData;
    }
}

?>
