<?php
include_once 'api.php';

function getserverpath()
{
  // Get icewarp server path
  $result=get_cfg_var('icewarp_server_path');
  if (!$result) {
    $result = dirname($_SERVER['SCRIPT_FILENAME']);
    $result = substr($result,0,strrpos($result,'html'));
  }
  return $result;
}

function getsyncmlpath()
{
  // Server path
  $result=getserverpath();

  // Check if load balance settings
  if (file_exists($result.'path.dat'))
	{
    // Load
    $items=@file($result.'path.dat');

    // Get groupware path
    $groupwarepath=trim($items[7]);
  }

  // Create groupware path
  if (!$groupwarepath)
		$result.='calendar/';
	else
		$result=$groupwarepath;

  // Final token
  return $result.='syncml/';
}

function server_config()
{
  $config_list=array();

  // Create server path
  $DataPath=getsyncmlpath();
  mkdirtree($DataPath);

  // Open settings
  $file=@fopen($DataPath.'config/settings.xml','rb');
  if ($file)
  {
    $config=fread($file,10000);
    fclose($file);

    $xml_config=text_to_xml($config);
    foreach($xml_config->children() as $field)
      $config_list[$field->get_name()]=strtolower($xml_config->get_data($field->get_name()));
  }
  // Session defaults
  $_SESSION['Disabled']=$config_list['Disabled']?$config_list['Disabled']:0;
  $_SESSION['DataPath']=$config_list['DataPath']?$config_list['DataPath']:$DataPath;
  
  if ($config_list['LogPath'])
  	$_SESSION['LogPath']=$config_list['LogPath'];
	else
	{
		$api=new MerakAPI();
		$_SESSION['LogPath']=$api->GetProperty('C_System_Storage_Dir_LogPath').'syncml/';
	}
		
  $_SESSION['LogLevel']=$config_list['LogLevel']?$config_list['LogLevel']:0;
  $_SESSION['RespURI']=$config_list['RespURI'];

  if (!$config_list['MaxMsgSize'])
    $config_list['MaxMsgSize']=1000000;

	if (!$config_list['AuthType'])
	  $config_list['AuthType']=3;

  return $config_list;
}


function do_log($body,$level=1,$filename='')
{
  // Check log level
  if ($level>$_SESSION['LogLevel'])
		return;

  // Set log filename
  if (!$filename)
		$filename=$_SESSION['LogPath'].date('Ymd',time()).'.log';
  mkdirtree(dirname($filename));

  // Open log file
  $file=@fopen($filename,'a');
  if ($file)
  {
    fputs($file,date('Y-m-d H:i:s ').'sid:'.session_id().' ');
    fputs($file,$body."\r\n");
    fclose($file);
  }
}

function mkdirtree($fpath)
{
  if($fpath!="" && !file_exists($fpath))
  {
    $fpath2=str_replace('\\','/',$fpath);
    $exparr=explode('/',$fpath2);

    for ($i=0;$i<count($exparr);$i++)
    {
      $dirline.= $exparr[$i].'/';
      if(!file_exists($dirline)) @mkdir($dirline,0750);
    }
  }
  return true;
}

function format_time($time)
{
 	if ($time>=60)
	{
		$min=intval($time/60);
		$time-=$min*60;
		$min.=':';
 	}
	return $min.round($time,3);
}
?>
