<?php
//SyncML server application framework

error_reporting(E_ALL ^E_NOTICE ^E_WARNING);
include_once 'function.php';
include_once 'syncml.php';
include_once 'wbxml.php';

//************************************************************
// SyncML server application framework
//************************************************************

$time=microtime(true);

//Is requested data SyncML?
$content_type=@$_SERVER['CONTENT_TYPE'];

if (($content_type!='application/vnd.syncml+xml')&&($content_type!='application/vnd.syncml+wbxml'))
{
	header('HTTP/1.1 403 Forbidden');
  exit;
}

//Read requested data
$request=file_get_contents('php://input');

//Save requested data to memory reprezentation of XML/WBXML structure
$xml_request=request_to_xml($request,$content_type);

$request_synchdr=new syncml_header($xml_request->get_child('SyncHdr'));
$request_syncbody=$xml_request->get_child('SyncBody');

//Identification of session
if ($_REQUEST['sid'])
  session_id($_REQUEST['sid']);
session_start();

//Have we new session?
if (!$_SESSION['sync_session'])
{
  $_SESSION['sync_session']=new syncml_session(server_config(),$content_type);
	$_SESSION['start_time']=$time;
  $_SESSION['total_time']=0;

  do_log('Session started ('.$content_type.')',1);
}

//Check if syncml disabled
if ($_SESSION['Disabled'])
{
	//Free session
  session_unset();
  session_destroy();

  header('HTTP/1.1 403 Forbidden');
  exit;
}

//Save requested message to logfile
do_log("<<<\r\n".$xml_request->print_node(0,true),2);

//Create response frame
$response=new wbxml_tree_node('SyncML',NULL);
$response_synchdr=&$response->new_child('SyncHdr',NULL);
$response_syncbody=&$response->new_child('SyncBody',NULL);

//Handle requested header and create response header
$_SESSION['sync_session']->handle_header($request_synchdr,&$response_syncbody);
$_SESSION['sync_session']->make_response_header(&$response_synchdr);

//Handle commands Alert, Get, Put, Map a Sync
$last_message=$_SESSION['sync_session']->handle_commands($request_syncbody,&$response_syncbody);

//Send complete response
if ($content_type=='application/vnd.syncml+xml')
  $response_str='<?xml version="1.0" encoding="UTF-8"?>'."\r\n".$response->print_node(0,false);
else
  $response_str=chr(2).chr(0).chr(0).chr(106).chr(29).'-//SYNCML//DTD SyncML '.$_SESSION['sync_session']->get_version().'//EN'.$response->print_wbxml();

header('Content-Type: '.$content_type);
header('Content-Length: '.strlen($response_str));
header('Accept-Charset: UTF-8');

echo $response_str;

//Save response message to logfile
$partial_time=microtime(true)-$time;
$_SESSION['total_time']+=$partial_time;

do_log('('.format_time($partial_time).") >>>\r\n".$response->print_node(0,true),2);
do_log('Message length:'.strlen($response_str).'  Data size:'.($_SESSION['sync_session']->_message_size*.5-$_SESSION['sync_session']->_datastore->get_free_place()),1);
$info=$_SESSION['sync_session']->get_info();
if ($info)
	do_log('('.format_time($partial_time).") \r\n".$info,1);

//Have we last message?
if ($last_message)
{
	do_log("\r\n".$_SESSION['sync_session']->get_summary(),1);

  //Terminate session
  do_log('Session terminated ('.format_time($_SESSION['total_time']).'/'.format_time(microtime(true)-$_SESSION['start_time']).')',1);

  session_unset();
  session_destroy();
}
?>
