<?php
include_once 'xml.php';
include_once 'api.php';

function getserverpath()
{
  // Get icewarp server path
  $result=get_cfg_var("icewarp_server_path");
  if (!$result) 
  {
    $result = dirname($_SERVER['SCRIPT_FILENAME']);
    $result = substr($result,0,strrpos($result,"html"));
  }
  return $result;
}

function getcaldavpath()
{
  // Server path
  $result=getserverpath();

  // Check if load balance settings
  if (file_exists($result."path.dat")) 
  {
    // Load
    $items=@file($result."path.dat");

    // Get groupware path
    $groupwarepath=trim($items[7]);
  }

  // Create groupware path
  if (!$groupwarepath) 
    $result.="calendar/"; 
  else $result=$groupwarepath;

  // Final token
  return $result.="caldav/";
}

function server_config()
{
  $config_list=array();

  // Create server path
  $DataPath=getcaldavpath();
  mkdirtree($DataPath);

  // Open settings
  $file=@fopen($DataPath."config/settings.xml","rb");
  if ($file)
  {
    $config=fread($file,10000);
    fclose($file);

    $xml_config=text_to_xml($config);
    foreach($xml_config->children() as $field)
      $config_list[$field->get_name()]=strtolower($xml_config->get_data($field->get_name()));
  }

  // Session defaults
  if (!$config_list["DataPath"]) 
    $_SESSION["DataPath"]=$DataPath;
  else
    $_SESSION["DataPath"]=$config_list["DataPath"];

  $_SESSION["Disabled"]=$config_list["Disabled"];
  $_SESSION["log_level"]=$config_list["LogLevel"];

  if ($config_list["LogPath"])
    $_SESSION["log_path"]=$config_list["LogPath"];  
  else
  {
    $api=new MerakAPI();
    $_SESSION['log_path']=$api->GetProperty('C_System_Storage_Dir_LogPath').'webdav/';
  }
}

function do_log($body,$level=1,$filename="")
{
  // Check log level
  if ($level>$_SESSION["log_level"]) return;

  // Set log filename
  if (!$filename) 
    $filename=$_SESSION["log_path"].date('Ymd',time()).'.log';
  
  mkdirtree(dirname($filename));

  // Open log file
  $file=@fopen($filename,"a");
  if ($file)
  {
    fputs($file,date("Y-m-d H:i:s ")."sid:".session_id()." ");
    fputs($file,$body."\r\n");
    fclose($file);
  }
}

function mkdirtree($fpath)
{
  if($fpath!="" && !file_exists($fpath))
  {
    $fpath2=str_replace("\\","/",$fpath);
    $exparr=explode("/",$fpath2);

    for ($i=0;$i<count($exparr);$i++)
    {
      $dirline.= $exparr[$i]."/";
      if(!file_exists($dirline)) 
        @mkdir($dirline,0750);
    }
  }
  return true;
}

function get_path()
{
  $fields=explode('/',$_SERVER['REQUEST_URI']);
  unset($fields[count($fields)-1]);
	return implode('/',$fields);
}
?>
