/*****************************************************
 * Extension script: Select form object
 *
 * INHERITS FROM obj_form_generic
 *    _me._value
 *    _me._disabled
 *    _me.__update
 *
 * @Date: 16.4.2006 16:33:51
 *****************************************************/
 
_me = obj_select.prototype;
function obj_select(){};

/**
 * @brief: CONSTRUCTOR, create select HTML element to __eIN variable
 * @date : 20.4.2006 17:26:58
 **/
_me.__constructor = function(){
	/* creates ELM directly, because simlicity of object */
	var elm = mkElement('select',{"name":this._pathName+'main',"id":this._pathName+'main',"className":this._type});
	this._main.appendChild(elm);

	this.__eIN = elm.form[elm.name];

	var me = this;

	this.__eIN.onchange = function(e){
		e = e || window.event;
		if(me._onchange) me._onchange(e);
	    me.__exeEvent('onchange',e,{"owner":me});
	}
    this.__eIN.onclick = function(e){
		e = e || window.event;
        if (me._onclick) me._onclick(e);
		me.__exeEvent('onclick',e,{"owner":me});
	}

	this.__eIN.ondblclick = this.__eIN.onclick;
};

   /**
    * @brief: Listen method for select options
    * @param: sDataSet - name of DataSet
    * @param: sDataSet (optional) - path into current data set structure
    * @date : 20.4.2006 17:27:33
    **/
	_me._listen_data = function(sDataSet,aDataPath){
		this._listener_data = sDataSet;
		if (typeof aDataPath == 'object') this._listenerPath_data = aDataPath;
		dataSet.obey(this,'_listener_data',sDataSet);
	};

   /**
    * @brief: Updata method, keeps data synchronized
    * @param: sDataSet - name of data set which is calling this method
    * @date : 20.4.2006 17:28:38
    **/
	_me.__update = function(sDataSet){
		if (!sDataSet) return;

		/* update options */
		if (this._listener_data == sDataSet)
			this._fill();

		/* update selected option */
		if (this._listener == sDataSet)
			this._value(dataSet.get(this._listener,this._listenerPath));
	};

   /**
    * @brief: Adds options into current select element
    * @param: aData (optional) - array of values as value,value or value:label
    * @date : 20.4.2006 17:33:24
    **/
	_me._fill = function(aData){

		// retrieve old value
		var oldValue = this._value();

		// if param aData is not set than retrieve data from dataset
		if (!aData) aData = dataSet.get(this._listener_data,this._listenerPath_data);

		var opt = this.__eIN.options;

		// clear content of select tag
	 	opt.length = 0;

		// add options from given array
		var array = false,i = 0;
		for (var key in aData)
			opt[opt.length] = new Option (aData[key],key, false, false);

		// set value back
		this._value(oldValue);
	};

	_me._multiple = function(b){
		this.__eIN.multiple = b?true:false;
	};

	_me._size = function(iSize){
		this.__eIN.size = parseInt(iSize) || 1;
	};

	_me._value = function(v){
		if (Is.Number(v)) v = v.toString();
		
		var opt = this.__eIN.options;
		var aOut = [];
		
		if (opt.length){
			for (var i = (opt.length-1);i>=0;i--){
			//	if (!opt[i]) continue;
				if (v){
					opt[i].selected = false;
					//for (var j in v){
						if (v == opt[i].value){
			    			opt[i].selected = true;
	                        aOut.push(v);
							break;
						}
	   				//}
				}
				else
					if (opt[i].selected) aOut.push(opt[i].value);
			}
		}
		return aOut;
	}

	_me._fillLang = function(aData){
      if (!aData) aData = dataSet.get(this._listener_data,this._listenerPath_data);

			var aData2 = {};
			for (var i in aData) aData2[i] = getLang(aData[i]);

			this._fill(aData2);
	};