<?
/* It is a parent class for cache class
 * Provides function to get correct 
 * IMAP folders and files
 */
class LocalPOPPaths extends DB
{
  /** The cache directory. */
	private $cacheDir;
	
	public function __construct($user,$cache)
  {
    // remove slash at the end of string
		$this->cacheDir = $user->getDir(true);
    $this->cache = $cache;
  }
  
  public function getCacheDir()
  {
      return $this->cacheDir . SETTINGS_FOLDER;
  }
  
	/**
	  @brief Get the name of the message file.
	  @return The name.
	 */
	private function getMessageFile($dir, $itemID)
	{
		//$this->cache->transaction();
		$stmt = $this->cache->prepare('SELECT rid
								FROM item
								WHERE item_id = ?');
		$stmt->execute(array($itemID));
		
		$row = $stmt->fetch();
	//	$this->cache->commit();
		
		if (!$row) {
			return false;
		}		
    	
		$itemRID = $row['rid'];
		return $dir . '/' . $itemRID . localpopmessageext;
	}

	/**
	  @brief Get the name of the message directory.
	  @return The name.
	 */
	private function getMessageDir($accountID, $folderID,$empty = false)
	{
    //$folderID = LocalPOP::encode($folderID);  

		//$this->cache->transaction();
		$stmt = $this->cache->prepare('SELECT name
								FROM folder
								WHERE folder_id = ?');
		$stmt->execute(array($folderID));
		
		$row = $stmt->fetch();
	///	$this->cache->commit();

		if (!$row) {
			return false;
		}
			
		$folderName = LocalPop::encode($row['name']);
		
		if (substr_count($folderName,'/')==0)
      if (!$empty) $folderName = eregi_replace('inbox','',$folderName);
    
		return $this->cacheDir.$folderName;
		
	}
	
	/**
	  @brief Get the path to the message file.
	  @return The path.
	 */
	public function getMessagePath($accountID, $folderName, $itemID)
	{ 	
		if (substr_count($folderName,'/')==0)
      $folderName = eregi_replace('inbox','',$folderName);
      
    $path =  $this->cacheDir . $folderName;
    
		return $this->getMessageFile($path, $itemID);
	}
}
?>
