<?php
require_once('inc/api/api.php');


class Search
{
  private static $base;
  
  private function __construct()
  {
    $this->api = new MerakAPI();
  }
  
  public static function instance()
  {
    if(!self::$base)
      self::$base = new TFullTextSearch();
      
    return self::$base;       
  }

  public function search($sPhrase,$sPath,$sExt = false,$bRCR = true){
    $this->iFound = 0;
    $aFiles = $this->search_r($sPhrase,$sPath,$sExt,$bRCR);
    return $aFiles;
  }
  
  private function search_r($sPhrase,$sPath,$sExt,$bRCR){
    $aResult = array();

    if ($oHandler = opendir($sPath)) {
      while (($sFile = readdir($oHandler)) !== false) {
        if (($sFile == '.') || ($sFile == '..'))
          continue;
          
        $sCurrent = $sPath.'/'.$sFile;

        if($sCurrent && is_dir($sCurrent)){
					if($bRCR) {
            if($aFiles = $this->search_r($sPhrase,$sCurrent,$sExt,$bRCR))
              $aResult = array_merge($aFiles,$aResult);
          }
        } else {
          if($sExt){
            $aInfo = pathinfo($sFile);
            if($aInfo['extension']!=$sExt) 
              continue;
          }
          //Process search
          $sContent = file_get_contents($sCurrent);
          if(strpos($sContent,$sPhrase))
            $aResult[] = $sCurrent;    
        }  
      }
      closedir($oHandler);
    }  
    
    return $aResult;  
  }  
}

?>
