<?php

/**
 * @brief		Class for quering global settings
 */
class Settings
{
		public $cApi;

		/**
		 * @brief		Public: Constructor
		 */
		function Settings()
		{

		}

		/**
		 * @brief		Static Public: Get type of OS
		 * @return		reference to 'win' | 'linux', DO NOT change
		 */
		function &getOS()
		{
				static $os;

				if (!isset($os)) {
						if (eregi("windows", $_ENV['OS']))
								$os = 'win';
						else
								$os = 'linux';
				}

				return($os);
		}

		/** NANIC
		 * @brief		Static Public: Get filesystem delimiter
		 * @return		reference to '\', '/' or other characters, DO NOT change
		 */
		function &getDelimiter()
		{
				static $delimiter;
				if (!isset($delimiter)) {
						switch (Settings::getOS()) {
								case 'win':
										$delimiter = '\\';
										break;
								case 'linux':
										$delimiter = '/';
										break;
						}
				}
				return($delimiter);
		}
}

?>
