<?php

require_once 'error.php';

/**
 * @brief  class for handling webmailIqGroups namespace
	@author Pavel Perna
	@date	04.05.2006
	@TODO	All 
 */
 class WebmailIqFriends extends XMLRequestInterface {
		
		private $sAID;	 //Groupware account id(email adress)
		
		private $oAccount; //Link to groupware account
		
		private $aActions = array("edit"=>1, "delete"=>1, "add"=>1, "export"=>1,"import"=>1);
		
		/**
		* @brief Public: Constructor
		* @param $oQuery A DOMElement filled with query element
		* @param $oDoc	A DOMDocument of the request
		* @param $attrs  An Array with parent attributes
		*/
		public function __construct($oQuery,&$oDoc,&$attrs)
		{
				$this->oQuery = $oQuery;
				$this->oDoc = &$oDoc;
				$this->aAttrs = &$attrs;

				$this->checkInputXML();
				$this->exeInputXML();

		}	
		
	  /**
		* @brief	Private - Checks if the input XML is valid
		* @return  TRUE/FALSE and throws exception
		*/		
		private function checkInputXML()
		{
				global $aError;	 
				
				if (!$this->oGroup = $this->oDoc->getNode("friends:group",$this->oQuery))
					  throw new Exc("f_missinggroup");
					  
				$this->pGWAccount = &$_SESSION['pGWAccount'];
				
				if (!is_object($this->pGWAccount))
					  throw new Exc("f_missinggwaccount");
					  
				if (!$this->sGID = $this->oGroup->getAttribute("uid"))
					  throw new Exc("f_missinggroupid");
				
				if ($this->aAttrs["type"]=='set')
				{					 
					  if (!$this->oFriend = $this->oDoc->getNode("friends:friend",$this->oGroup))
							throw new Exc("f_missingfriend");
							
				}			
						
		}

	  /**
		* @brief	Private: Do operations dependent on 'query xmlns'
		* @return		XML subanswer (string)
		*/
		private function exeInputXML()
		{		
				$this->pGWAPI = &$this->pGWAccount->gwAPI; 
				if (!$this->pGWAccount->gwAPI->IsConnected())
				{
					  $this->pGWAccount->gwAPI->Login();
					  $this->pGWAccount->gSID = $this->pGWAccount->gwAPI->OpenGroup("*");
				}			  
				// Open GW group to work with 
				$sGSID = $this->oGWAPI->OpenGroup($this->sGID);

				switch($this->aAttrs["type"])
				{
					case 'get': 
						
						// Set template file
						$this->sTemplateFile = 'webmailiqfriends_get';  
						
						// Retrieve friend list
						$sFriends = $this->pGWAPI->FunctionCall("GetGroupUsers",$sGSID);
						$aFriends = $this->pGWAPI->ParseParamLine($sFriends);
						
						// Fill template data
						$this->aData["friend"]["num"] = $this->cnvFriends($aFriends);		 
						break;		
					case 'set':
					
						switch ($this->sGAction)
						{
							  case "add":
									$this->pGWAPI->FunctionCall("AddGroupUser",$this->pGWAPI->sessid,$this->sParameters);
									break;
							  case "delete":
									$gwapi->FunctionCall("DeleteGroupUser",$this->pGWAccount->gSID,$pom);
									break;
						}
				}
				
				// Close GW group 
				$this->pGWAPI->CloseGroup($sGSID);
				 
		}

	  /**
		*  @brief Converts groups array into template compatible data array
		*  @param $groups Array of groups
		*  @return groups array in the form for template system
		*/			
		private function cnvFriends($friends){
		  if (!is_array($friends)) return;
		  foreach($friends as $friend){
			$aItem["id"] = $friend["USR_ID"];
			$aItem["sFields"] = Tools::makeXMLTags($friend);
			
			$aItems[] = $aItem;
		  }
		  return $aItems;
		}	  
}
		
?>

